#ifndef _H_8A0DCF3A491560B9C45AF8793A8BAE37_PointHead_Goal_Request__H_
#define _H_8A0DCF3A491560B9C45AF8793A8BAE37_PointHead_Goal_Request__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "geometry_msgs/msg/dds_opensplice/PointStamped_.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            struct  PointHead_Goal_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ action_goal_id_;
                ::geometry_msgs::msg::dds_::PointStamped_ target_;
                ::geometry_msgs::msg::dds_::Vector3_ pointing_axis_;
                ::DDS::String_mgr pointing_frame_;
                ::builtin_interfaces::msg::dds_::Duration_ min_duration_;
                ::DDS::Double max_velocity_;
            };

            typedef DDS_DCPSStruct_var<PointHead_Goal_Request_> PointHead_Goal_Request__var;
            typedef DDS_DCPSStruct_out < PointHead_Goal_Request_> PointHead_Goal_Request__out;

        }

    }

}

#endif /* _H_8A0DCF3A491560B9C45AF8793A8BAE37_PointHead_Goal_Request__H_ */
