#ifndef H_8A0DCF3A491560B9C45AF8793A8BAE37_PointHead_Goal_Request_SPLTYPES_H
#define H_8A0DCF3A491560B9C45AF8793A8BAE37_PointHead_Goal_Request_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_PointHead_Goal_Request_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/PointStamped_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_SplDcps.h"



extern c_metaObject __PointHead_Goal_Request__control_msgs__load (c_base base);

extern c_metaObject __PointHead_Goal_Request__control_msgs_action__load (c_base base);

extern c_metaObject __PointHead_Goal_Request__control_msgs_action_dds___load (c_base base);

extern const char *control_msgs_action_dds__PointHead_Goal_Request__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_Goal_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_Goal_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_Goal_Request___load (c_base base);
struct _control_msgs_action_dds__PointHead_Goal_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_Goal_Request___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_Goal_Request_ *from, struct _control_msgs_action_dds__PointHead_Goal_Request_ *to);
extern  void __control_msgs_action_dds__PointHead_Goal_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_Goal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ action_goal_id_;
    struct _geometry_msgs_msg_dds__PointStamped_ target_;
    struct _geometry_msgs_msg_dds__Vector3_ pointing_axis_;
    c_string pointing_frame_;
    struct _builtin_interfaces_msg_dds__Duration_ min_duration_;
    c_double max_velocity_;
};

#undef OS_API
#endif
