#ifndef _H_6C4C09F21BE184F715AE5CCC1A4229D4_PointHead_Result_Response_DCPS_H_
#define _H_6C4C09F21BE184F715AE5CCC1A4229D4_PointHead_Result_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointHead_Result_Response_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            class PointHead_Result_Response_TypeSupportInterface;

            typedef PointHead_Result_Response_TypeSupportInterface * PointHead_Result_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Result_Response_TypeSupportInterface> PointHead_Result_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_Result_Response_TypeSupportInterface> PointHead_Result_Response_TypeSupportInterface_out;


            class PointHead_Result_Response_DataWriter;

            typedef PointHead_Result_Response_DataWriter * PointHead_Result_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Result_Response_DataWriter> PointHead_Result_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_Result_Response_DataWriter> PointHead_Result_Response_DataWriter_out;


            class PointHead_Result_Response_DataReader;

            typedef PointHead_Result_Response_DataReader * PointHead_Result_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Result_Response_DataReader> PointHead_Result_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_Result_Response_DataReader> PointHead_Result_Response_DataReader_out;


            class PointHead_Result_Response_DataReaderView;

            typedef PointHead_Result_Response_DataReaderView * PointHead_Result_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Result_Response_DataReaderView> PointHead_Result_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_Result_Response_DataReaderView> PointHead_Result_Response_DataReaderView_out;

            struct PointHead_Result_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PointHead_Result_Response_, struct PointHead_Result_Response_Seq_uniq_> PointHead_Result_Response_Seq;
            typedef DDS_DCPSSequence_var < PointHead_Result_Response_Seq> PointHead_Result_Response_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_Result_Response_Seq> PointHead_Result_Response_Seq_out;

            class  PointHead_Result_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_Result_Response_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_Result_Response_TypeSupportInterface_var _var_type;

                static PointHead_Result_Response_TypeSupportInterface_ptr _duplicate (PointHead_Result_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Result_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Result_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Result_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Result_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_Result_Response_TypeSupportInterface () {};
                ~PointHead_Result_Response_TypeSupportInterface () {};
            private:
                PointHead_Result_Response_TypeSupportInterface (const PointHead_Result_Response_TypeSupportInterface &);
                PointHead_Result_Response_TypeSupportInterface & operator = (const PointHead_Result_Response_TypeSupportInterface &);
            };

            class  PointHead_Result_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_Result_Response_DataWriter_ptr _ptr_type;
                typedef PointHead_Result_Response_DataWriter_var _var_type;

                static PointHead_Result_Response_DataWriter_ptr _duplicate (PointHead_Result_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Result_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Result_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Result_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Result_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_Result_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_Result_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_Result_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_Result_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_Result_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_Result_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_Result_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_Result_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_Result_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_Result_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_Result_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Result_Response_& instance_data) = 0;

            protected:
                PointHead_Result_Response_DataWriter () {};
                ~PointHead_Result_Response_DataWriter () {};
            private:
                PointHead_Result_Response_DataWriter (const PointHead_Result_Response_DataWriter &);
                PointHead_Result_Response_DataWriter & operator = (const PointHead_Result_Response_DataWriter &);
            };

            class  PointHead_Result_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_Result_Response_DataReader_ptr _ptr_type;
                typedef PointHead_Result_Response_DataReader_var _var_type;

                static PointHead_Result_Response_DataReader_ptr _duplicate (PointHead_Result_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Result_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Result_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Result_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Result_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_Result_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_Result_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_Result_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Result_Response_& instance) = 0;

            protected:
                PointHead_Result_Response_DataReader () {};
                ~PointHead_Result_Response_DataReader () {};
            private:
                PointHead_Result_Response_DataReader (const PointHead_Result_Response_DataReader &);
                PointHead_Result_Response_DataReader & operator = (const PointHead_Result_Response_DataReader &);
            };

            class  PointHead_Result_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_Result_Response_DataReaderView_ptr _ptr_type;
                typedef PointHead_Result_Response_DataReaderView_var _var_type;

                static PointHead_Result_Response_DataReaderView_ptr _duplicate (PointHead_Result_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Result_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Result_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Result_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Result_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_Result_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_Result_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_Result_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_Result_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Result_Response_& instance) = 0;

            protected:
                PointHead_Result_Response_DataReaderView () {};
                ~PointHead_Result_Response_DataReaderView () {};
            private:
                PointHead_Result_Response_DataReaderView (const PointHead_Result_Response_DataReaderView &);
                PointHead_Result_Response_DataReaderView & operator = (const PointHead_Result_Response_DataReaderView &);
            };
        }

    }

}

#endif
