#ifndef _H_42D533765FB5D019836DF43E9D4EBBE9_SingleJointPosition_Feedback_DCPS_H_
#define _H_42D533765FB5D019836DF43E9D4EBBE9_SingleJointPosition_Feedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SingleJointPosition_Feedback_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            class SingleJointPosition_Feedback_TypeSupportInterface;

            typedef SingleJointPosition_Feedback_TypeSupportInterface * SingleJointPosition_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Feedback_TypeSupportInterface> SingleJointPosition_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Feedback_TypeSupportInterface> SingleJointPosition_Feedback_TypeSupportInterface_out;


            class SingleJointPosition_Feedback_DataWriter;

            typedef SingleJointPosition_Feedback_DataWriter * SingleJointPosition_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Feedback_DataWriter> SingleJointPosition_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Feedback_DataWriter> SingleJointPosition_Feedback_DataWriter_out;


            class SingleJointPosition_Feedback_DataReader;

            typedef SingleJointPosition_Feedback_DataReader * SingleJointPosition_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Feedback_DataReader> SingleJointPosition_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Feedback_DataReader> SingleJointPosition_Feedback_DataReader_out;


            class SingleJointPosition_Feedback_DataReaderView;

            typedef SingleJointPosition_Feedback_DataReaderView * SingleJointPosition_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Feedback_DataReaderView> SingleJointPosition_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Feedback_DataReaderView> SingleJointPosition_Feedback_DataReaderView_out;

            struct SingleJointPosition_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SingleJointPosition_Feedback_, struct SingleJointPosition_Feedback_Seq_uniq_> SingleJointPosition_Feedback_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_Feedback_Seq> SingleJointPosition_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_Feedback_Seq> SingleJointPosition_Feedback_Seq_out;

            class  SingleJointPosition_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_Feedback_TypeSupportInterface_var _var_type;

                static SingleJointPosition_Feedback_TypeSupportInterface_ptr _duplicate (SingleJointPosition_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_Feedback_TypeSupportInterface () {};
                ~SingleJointPosition_Feedback_TypeSupportInterface () {};
            private:
                SingleJointPosition_Feedback_TypeSupportInterface (const SingleJointPosition_Feedback_TypeSupportInterface &);
                SingleJointPosition_Feedback_TypeSupportInterface & operator = (const SingleJointPosition_Feedback_TypeSupportInterface &);
            };

            class  SingleJointPosition_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_Feedback_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_Feedback_DataWriter_var _var_type;

                static SingleJointPosition_Feedback_DataWriter_ptr _duplicate (SingleJointPosition_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Feedback_& instance_data) = 0;

            protected:
                SingleJointPosition_Feedback_DataWriter () {};
                ~SingleJointPosition_Feedback_DataWriter () {};
            private:
                SingleJointPosition_Feedback_DataWriter (const SingleJointPosition_Feedback_DataWriter &);
                SingleJointPosition_Feedback_DataWriter & operator = (const SingleJointPosition_Feedback_DataWriter &);
            };

            class  SingleJointPosition_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_Feedback_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_Feedback_DataReader_var _var_type;

                static SingleJointPosition_Feedback_DataReader_ptr _duplicate (SingleJointPosition_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Feedback_& instance) = 0;

            protected:
                SingleJointPosition_Feedback_DataReader () {};
                ~SingleJointPosition_Feedback_DataReader () {};
            private:
                SingleJointPosition_Feedback_DataReader (const SingleJointPosition_Feedback_DataReader &);
                SingleJointPosition_Feedback_DataReader & operator = (const SingleJointPosition_Feedback_DataReader &);
            };

            class  SingleJointPosition_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_Feedback_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_Feedback_DataReaderView_var _var_type;

                static SingleJointPosition_Feedback_DataReaderView_ptr _duplicate (SingleJointPosition_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Feedback_& instance) = 0;

            protected:
                SingleJointPosition_Feedback_DataReaderView () {};
                ~SingleJointPosition_Feedback_DataReaderView () {};
            private:
                SingleJointPosition_Feedback_DataReaderView (const SingleJointPosition_Feedback_DataReaderView &);
                SingleJointPosition_Feedback_DataReaderView & operator = (const SingleJointPosition_Feedback_DataReaderView &);
            };
        }

    }

}

#endif
