#ifndef _H_5D3F8CD6095994F90640C8A5D3C0688F_SingleJointPosition_Goal_Request_DCPS_H_
#define _H_5D3F8CD6095994F90640C8A5D3C0688F_SingleJointPosition_Goal_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SingleJointPosition_Goal_Request_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            class SingleJointPosition_Goal_Request_TypeSupportInterface;

            typedef SingleJointPosition_Goal_Request_TypeSupportInterface * SingleJointPosition_Goal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Goal_Request_TypeSupportInterface> SingleJointPosition_Goal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Goal_Request_TypeSupportInterface> SingleJointPosition_Goal_Request_TypeSupportInterface_out;


            class SingleJointPosition_Goal_Request_DataWriter;

            typedef SingleJointPosition_Goal_Request_DataWriter * SingleJointPosition_Goal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Goal_Request_DataWriter> SingleJointPosition_Goal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Goal_Request_DataWriter> SingleJointPosition_Goal_Request_DataWriter_out;


            class SingleJointPosition_Goal_Request_DataReader;

            typedef SingleJointPosition_Goal_Request_DataReader * SingleJointPosition_Goal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Goal_Request_DataReader> SingleJointPosition_Goal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Goal_Request_DataReader> SingleJointPosition_Goal_Request_DataReader_out;


            class SingleJointPosition_Goal_Request_DataReaderView;

            typedef SingleJointPosition_Goal_Request_DataReaderView * SingleJointPosition_Goal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Goal_Request_DataReaderView> SingleJointPosition_Goal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Goal_Request_DataReaderView> SingleJointPosition_Goal_Request_DataReaderView_out;

            struct SingleJointPosition_Goal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SingleJointPosition_Goal_Request_, struct SingleJointPosition_Goal_Request_Seq_uniq_> SingleJointPosition_Goal_Request_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_Goal_Request_Seq> SingleJointPosition_Goal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_Goal_Request_Seq> SingleJointPosition_Goal_Request_Seq_out;

            class  SingleJointPosition_Goal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_Goal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_Goal_Request_TypeSupportInterface_var _var_type;

                static SingleJointPosition_Goal_Request_TypeSupportInterface_ptr _duplicate (SingleJointPosition_Goal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Goal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Goal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_Goal_Request_TypeSupportInterface () {};
                ~SingleJointPosition_Goal_Request_TypeSupportInterface () {};
            private:
                SingleJointPosition_Goal_Request_TypeSupportInterface (const SingleJointPosition_Goal_Request_TypeSupportInterface &);
                SingleJointPosition_Goal_Request_TypeSupportInterface & operator = (const SingleJointPosition_Goal_Request_TypeSupportInterface &);
            };

            class  SingleJointPosition_Goal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_Goal_Request_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_Goal_Request_DataWriter_var _var_type;

                static SingleJointPosition_Goal_Request_DataWriter_ptr _duplicate (SingleJointPosition_Goal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Goal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Goal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_Goal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_Goal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_Goal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_Goal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_Goal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_Goal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_Goal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_Goal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_Goal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_Goal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Goal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Goal_Request_& instance_data) = 0;

            protected:
                SingleJointPosition_Goal_Request_DataWriter () {};
                ~SingleJointPosition_Goal_Request_DataWriter () {};
            private:
                SingleJointPosition_Goal_Request_DataWriter (const SingleJointPosition_Goal_Request_DataWriter &);
                SingleJointPosition_Goal_Request_DataWriter & operator = (const SingleJointPosition_Goal_Request_DataWriter &);
            };

            class  SingleJointPosition_Goal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_Goal_Request_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_Goal_Request_DataReader_var _var_type;

                static SingleJointPosition_Goal_Request_DataReader_ptr _duplicate (SingleJointPosition_Goal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Goal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Goal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Goal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Goal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Goal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Goal_Request_& instance) = 0;

            protected:
                SingleJointPosition_Goal_Request_DataReader () {};
                ~SingleJointPosition_Goal_Request_DataReader () {};
            private:
                SingleJointPosition_Goal_Request_DataReader (const SingleJointPosition_Goal_Request_DataReader &);
                SingleJointPosition_Goal_Request_DataReader & operator = (const SingleJointPosition_Goal_Request_DataReader &);
            };

            class  SingleJointPosition_Goal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_Goal_Request_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_Goal_Request_DataReaderView_var _var_type;

                static SingleJointPosition_Goal_Request_DataReaderView_ptr _duplicate (SingleJointPosition_Goal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Goal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Goal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Goal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Goal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Goal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Goal_Request_& instance) = 0;

            protected:
                SingleJointPosition_Goal_Request_DataReaderView () {};
                ~SingleJointPosition_Goal_Request_DataReaderView () {};
            private:
                SingleJointPosition_Goal_Request_DataReaderView (const SingleJointPosition_Goal_Request_DataReaderView &);
                SingleJointPosition_Goal_Request_DataReaderView & operator = (const SingleJointPosition_Goal_Request_DataReaderView &);
            };
        }

    }

}

#endif
