// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef CONTROL_MSGS__ACTION__GRIPPER_COMMAND__RESULT__RESPONSE__STRUCT_HPP_
#define CONTROL_MSGS__ACTION__GRIPPER_COMMAND__RESULT__RESPONSE__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies

#ifndef _WIN32
# define DEPRECATED_control_msgs_action_GripperCommand_Result_Response __attribute__((deprecated))
#else
# define DEPRECATED_control_msgs_action_GripperCommand_Result_Response __declspec(deprecated)
#endif

namespace control_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GripperCommand_Result_Response_
{
  using Type = GripperCommand_Result_Response_<ContainerAllocator>;

  explicit GripperCommand_Result_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_status = 0;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->position = 0.0;
      this->effort = 0.0;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->stalled = false;
      this->reached_goal = false;
    }
  }

  explicit GripperCommand_Result_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_status = 0;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->position = 0.0;
      this->effort = 0.0;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->stalled = false;
      this->reached_goal = false;
    }
  }

  // field types and members
  using _action_status_type =
    int8_t;
  _action_status_type action_status;
  using _position_type =
    double;
  _position_type position;
  using _effort_type =
    double;
  _effort_type effort;
  using _stalled_type =
    bool;
  _stalled_type stalled;
  using _reached_goal_type =
    bool;
  _reached_goal_type reached_goal;

  // setters for named parameter idiom
  Type * set__action_status(
    const int8_t & _arg)
  {
    this->action_status = _arg;
    return this;
  }
  Type * set__position(
    const double & _arg)
  {
    this->position = _arg;
    return this;
  }
  Type * set__effort(
    const double & _arg)
  {
    this->effort = _arg;
    return this;
  }
  Type * set__stalled(
    const bool & _arg)
  {
    this->stalled = _arg;
    return this;
  }
  Type * set__reached_goal(
    const bool & _arg)
  {
    this->reached_goal = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_control_msgs_action_GripperCommand_Result_Response
    std::shared_ptr<control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_control_msgs_action_GripperCommand_Result_Response
    std::shared_ptr<control_msgs::action::GripperCommand_Result_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GripperCommand_Result_Response_ & other) const
  {
    if (this->action_status != other.action_status) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->effort != other.effort) {
      return false;
    }
    if (this->stalled != other.stalled) {
      return false;
    }
    if (this->reached_goal != other.reached_goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const GripperCommand_Result_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GripperCommand_Result_Response_

// alias to use template instance with default allocator
using GripperCommand_Result_Response =
  control_msgs::action::GripperCommand_Result_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace control_msgs

#endif  // CONTROL_MSGS__ACTION__GRIPPER_COMMAND__RESULT__RESPONSE__STRUCT_HPP_
