// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef CONTROL_MSGS__ACTION__POINT_HEAD__FEEDBACK__STRUCT_HPP_
#define CONTROL_MSGS__ACTION__POINT_HEAD__FEEDBACK__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "unique_identifier_msgs/msg/uuid.hpp"  // action_goal_id

#ifndef _WIN32
# define DEPRECATED_control_msgs_action_PointHead_Feedback __attribute__((deprecated))
#else
# define DEPRECATED_control_msgs_action_PointHead_Feedback __declspec(deprecated)
#endif

namespace control_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PointHead_Feedback_
{
  using Type = PointHead_Feedback_<ContainerAllocator>;

  explicit PointHead_Feedback_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action_goal_id(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->pointing_angle_error = 0.0;
    }
  }

  explicit PointHead_Feedback_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action_goal_id(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->pointing_angle_error = 0.0;
    }
  }

  // field types and members
  using _action_goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _action_goal_id_type action_goal_id;
  using _pointing_angle_error_type =
    double;
  _pointing_angle_error_type pointing_angle_error;

  // setters for named parameter idiom
  Type * set__action_goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->action_goal_id = _arg;
    return this;
  }
  Type * set__pointing_angle_error(
    const double & _arg)
  {
    this->pointing_angle_error = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    control_msgs::action::PointHead_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const control_msgs::action::PointHead_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<control_msgs::action::PointHead_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<control_msgs::action::PointHead_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      control_msgs::action::PointHead_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<control_msgs::action::PointHead_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      control_msgs::action::PointHead_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<control_msgs::action::PointHead_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<control_msgs::action::PointHead_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<control_msgs::action::PointHead_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_control_msgs_action_PointHead_Feedback
    std::shared_ptr<control_msgs::action::PointHead_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_control_msgs_action_PointHead_Feedback
    std::shared_ptr<control_msgs::action::PointHead_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PointHead_Feedback_ & other) const
  {
    if (this->action_goal_id != other.action_goal_id) {
      return false;
    }
    if (this->pointing_angle_error != other.pointing_angle_error) {
      return false;
    }
    return true;
  }
  bool operator!=(const PointHead_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PointHead_Feedback_

// alias to use template instance with default allocator
using PointHead_Feedback =
  control_msgs::action::PointHead_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace control_msgs

#endif  // CONTROL_MSGS__ACTION__POINT_HEAD__FEEDBACK__STRUCT_HPP_
