// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef CONTROL_MSGS__ACTION__SINGLE_JOINT_POSITION__GOAL__REQUEST__STRUCT_HPP_
#define CONTROL_MSGS__ACTION__SINGLE_JOINT_POSITION__GOAL__REQUEST__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "builtin_interfaces/msg/duration.hpp"  // min_duration
#include "unique_identifier_msgs/msg/uuid.hpp"  // action_goal_id

#ifndef _WIN32
# define DEPRECATED_control_msgs_action_SingleJointPosition_Goal_Request __attribute__((deprecated))
#else
# define DEPRECATED_control_msgs_action_SingleJointPosition_Goal_Request __declspec(deprecated)
#endif

namespace control_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SingleJointPosition_Goal_Request_
{
  using Type = SingleJointPosition_Goal_Request_<ContainerAllocator>;

  explicit SingleJointPosition_Goal_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action_goal_id(_init),
    min_duration(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->position = 0.0;
      this->max_velocity = 0.0;
    }
  }

  explicit SingleJointPosition_Goal_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action_goal_id(_alloc, _init),
    min_duration(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->position = 0.0;
      this->max_velocity = 0.0;
    }
  }

  // field types and members
  using _action_goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _action_goal_id_type action_goal_id;
  using _position_type =
    double;
  _position_type position;
  using _min_duration_type =
    builtin_interfaces::msg::Duration_<ContainerAllocator>;
  _min_duration_type min_duration;
  using _max_velocity_type =
    double;
  _max_velocity_type max_velocity;

  // setters for named parameter idiom
  Type * set__action_goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->action_goal_id = _arg;
    return this;
  }
  Type * set__position(
    const double & _arg)
  {
    this->position = _arg;
    return this;
  }
  Type * set__min_duration(
    const builtin_interfaces::msg::Duration_<ContainerAllocator> & _arg)
  {
    this->min_duration = _arg;
    return this;
  }
  Type * set__max_velocity(
    const double & _arg)
  {
    this->max_velocity = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_control_msgs_action_SingleJointPosition_Goal_Request
    std::shared_ptr<control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_control_msgs_action_SingleJointPosition_Goal_Request
    std::shared_ptr<control_msgs::action::SingleJointPosition_Goal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SingleJointPosition_Goal_Request_ & other) const
  {
    if (this->action_goal_id != other.action_goal_id) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->min_duration != other.min_duration) {
      return false;
    }
    if (this->max_velocity != other.max_velocity) {
      return false;
    }
    return true;
  }
  bool operator!=(const SingleJointPosition_Goal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SingleJointPosition_Goal_Request_

// alias to use template instance with default allocator
using SingleJointPosition_Goal_Request =
  control_msgs::action::SingleJointPosition_Goal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace control_msgs

#endif  // CONTROL_MSGS__ACTION__SINGLE_JOINT_POSITION__GOAL__REQUEST__STRUCT_HPP_
