#ifndef _H_32AD923CC3F1B16725DDDF8A34216361_GripperCommand_Feedback__H_
#define _H_32AD923CC3F1B16725DDDF8A34216361_GripperCommand_Feedback__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            struct  GripperCommand_Feedback_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ action_goal_id_;
                ::DDS::Double position_;
                ::DDS::Double effort_;
                ::DDS::Boolean stalled_;
                ::DDS::Boolean reached_goal_;
            };

            typedef DDS_DCPSStruct_var<GripperCommand_Feedback_> GripperCommand_Feedback__var;
            typedef GripperCommand_Feedback_& GripperCommand_Feedback__out;

        }

    }

}

#endif /* _H_32AD923CC3F1B16725DDDF8A34216361_GripperCommand_Feedback__H_ */
