#ifndef _H_32AD923CC3F1B16725DDDF8A34216361_GripperCommand_Feedback_DCPS_H_
#define _H_32AD923CC3F1B16725DDDF8A34216361_GripperCommand_Feedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GripperCommand_Feedback_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            class GripperCommand_Feedback_TypeSupportInterface;

            typedef GripperCommand_Feedback_TypeSupportInterface * GripperCommand_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Feedback_TypeSupportInterface> GripperCommand_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Feedback_TypeSupportInterface> GripperCommand_Feedback_TypeSupportInterface_out;


            class GripperCommand_Feedback_DataWriter;

            typedef GripperCommand_Feedback_DataWriter * GripperCommand_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Feedback_DataWriter> GripperCommand_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Feedback_DataWriter> GripperCommand_Feedback_DataWriter_out;


            class GripperCommand_Feedback_DataReader;

            typedef GripperCommand_Feedback_DataReader * GripperCommand_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Feedback_DataReader> GripperCommand_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Feedback_DataReader> GripperCommand_Feedback_DataReader_out;


            class GripperCommand_Feedback_DataReaderView;

            typedef GripperCommand_Feedback_DataReaderView * GripperCommand_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Feedback_DataReaderView> GripperCommand_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Feedback_DataReaderView> GripperCommand_Feedback_DataReaderView_out;

            struct GripperCommand_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_Feedback_, struct GripperCommand_Feedback_Seq_uniq_> GripperCommand_Feedback_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_Feedback_Seq> GripperCommand_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_Feedback_Seq> GripperCommand_Feedback_Seq_out;

            class  GripperCommand_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_Feedback_TypeSupportInterface_var _var_type;

                static GripperCommand_Feedback_TypeSupportInterface_ptr _duplicate (GripperCommand_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_Feedback_TypeSupportInterface () {};
                ~GripperCommand_Feedback_TypeSupportInterface () {};
            private:
                GripperCommand_Feedback_TypeSupportInterface (const GripperCommand_Feedback_TypeSupportInterface &);
                GripperCommand_Feedback_TypeSupportInterface & operator = (const GripperCommand_Feedback_TypeSupportInterface &);
            };

            class  GripperCommand_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_Feedback_DataWriter_ptr _ptr_type;
                typedef GripperCommand_Feedback_DataWriter_var _var_type;

                static GripperCommand_Feedback_DataWriter_ptr _duplicate (GripperCommand_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Feedback_& instance_data) = 0;

            protected:
                GripperCommand_Feedback_DataWriter () {};
                ~GripperCommand_Feedback_DataWriter () {};
            private:
                GripperCommand_Feedback_DataWriter (const GripperCommand_Feedback_DataWriter &);
                GripperCommand_Feedback_DataWriter & operator = (const GripperCommand_Feedback_DataWriter &);
            };

            class  GripperCommand_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_Feedback_DataReader_ptr _ptr_type;
                typedef GripperCommand_Feedback_DataReader_var _var_type;

                static GripperCommand_Feedback_DataReader_ptr _duplicate (GripperCommand_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Feedback_& instance) = 0;

            protected:
                GripperCommand_Feedback_DataReader () {};
                ~GripperCommand_Feedback_DataReader () {};
            private:
                GripperCommand_Feedback_DataReader (const GripperCommand_Feedback_DataReader &);
                GripperCommand_Feedback_DataReader & operator = (const GripperCommand_Feedback_DataReader &);
            };

            class  GripperCommand_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_Feedback_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_Feedback_DataReaderView_var _var_type;

                static GripperCommand_Feedback_DataReaderView_ptr _duplicate (GripperCommand_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Feedback_& instance) = 0;

            protected:
                GripperCommand_Feedback_DataReaderView () {};
                ~GripperCommand_Feedback_DataReaderView () {};
            private:
                GripperCommand_Feedback_DataReaderView (const GripperCommand_Feedback_DataReaderView &);
                GripperCommand_Feedback_DataReaderView & operator = (const GripperCommand_Feedback_DataReaderView &);
            };
        }

    }

}

#endif
