#ifndef _H_C9F33FD36C25D055DB27228CDC40142D_GripperCommand_Goal_Request_DCPS_H_
#define _H_C9F33FD36C25D055DB27228CDC40142D_GripperCommand_Goal_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GripperCommand_Goal_Request_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            class GripperCommand_Goal_Request_TypeSupportInterface;

            typedef GripperCommand_Goal_Request_TypeSupportInterface * GripperCommand_Goal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Goal_Request_TypeSupportInterface> GripperCommand_Goal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Goal_Request_TypeSupportInterface> GripperCommand_Goal_Request_TypeSupportInterface_out;


            class GripperCommand_Goal_Request_DataWriter;

            typedef GripperCommand_Goal_Request_DataWriter * GripperCommand_Goal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Goal_Request_DataWriter> GripperCommand_Goal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Goal_Request_DataWriter> GripperCommand_Goal_Request_DataWriter_out;


            class GripperCommand_Goal_Request_DataReader;

            typedef GripperCommand_Goal_Request_DataReader * GripperCommand_Goal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Goal_Request_DataReader> GripperCommand_Goal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Goal_Request_DataReader> GripperCommand_Goal_Request_DataReader_out;


            class GripperCommand_Goal_Request_DataReaderView;

            typedef GripperCommand_Goal_Request_DataReaderView * GripperCommand_Goal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Goal_Request_DataReaderView> GripperCommand_Goal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Goal_Request_DataReaderView> GripperCommand_Goal_Request_DataReaderView_out;

            struct GripperCommand_Goal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_Goal_Request_, struct GripperCommand_Goal_Request_Seq_uniq_> GripperCommand_Goal_Request_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_Goal_Request_Seq> GripperCommand_Goal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_Goal_Request_Seq> GripperCommand_Goal_Request_Seq_out;

            class  GripperCommand_Goal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_Goal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_Goal_Request_TypeSupportInterface_var _var_type;

                static GripperCommand_Goal_Request_TypeSupportInterface_ptr _duplicate (GripperCommand_Goal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Goal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Goal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_Goal_Request_TypeSupportInterface () {};
                ~GripperCommand_Goal_Request_TypeSupportInterface () {};
            private:
                GripperCommand_Goal_Request_TypeSupportInterface (const GripperCommand_Goal_Request_TypeSupportInterface &);
                GripperCommand_Goal_Request_TypeSupportInterface & operator = (const GripperCommand_Goal_Request_TypeSupportInterface &);
            };

            class  GripperCommand_Goal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_Goal_Request_DataWriter_ptr _ptr_type;
                typedef GripperCommand_Goal_Request_DataWriter_var _var_type;

                static GripperCommand_Goal_Request_DataWriter_ptr _duplicate (GripperCommand_Goal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Goal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Goal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_Goal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_Goal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_Goal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_Goal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_Goal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_Goal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_Goal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_Goal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_Goal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_Goal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Goal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Goal_Request_& instance_data) = 0;

            protected:
                GripperCommand_Goal_Request_DataWriter () {};
                ~GripperCommand_Goal_Request_DataWriter () {};
            private:
                GripperCommand_Goal_Request_DataWriter (const GripperCommand_Goal_Request_DataWriter &);
                GripperCommand_Goal_Request_DataWriter & operator = (const GripperCommand_Goal_Request_DataWriter &);
            };

            class  GripperCommand_Goal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_Goal_Request_DataReader_ptr _ptr_type;
                typedef GripperCommand_Goal_Request_DataReader_var _var_type;

                static GripperCommand_Goal_Request_DataReader_ptr _duplicate (GripperCommand_Goal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Goal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Goal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Goal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Goal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Goal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Goal_Request_& instance) = 0;

            protected:
                GripperCommand_Goal_Request_DataReader () {};
                ~GripperCommand_Goal_Request_DataReader () {};
            private:
                GripperCommand_Goal_Request_DataReader (const GripperCommand_Goal_Request_DataReader &);
                GripperCommand_Goal_Request_DataReader & operator = (const GripperCommand_Goal_Request_DataReader &);
            };

            class  GripperCommand_Goal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_Goal_Request_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_Goal_Request_DataReaderView_var _var_type;

                static GripperCommand_Goal_Request_DataReaderView_ptr _duplicate (GripperCommand_Goal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Goal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Goal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Goal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Goal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Goal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Goal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Goal_Request_& instance) = 0;

            protected:
                GripperCommand_Goal_Request_DataReaderView () {};
                ~GripperCommand_Goal_Request_DataReaderView () {};
            private:
                GripperCommand_Goal_Request_DataReaderView (const GripperCommand_Goal_Request_DataReaderView &);
                GripperCommand_Goal_Request_DataReaderView & operator = (const GripperCommand_Goal_Request_DataReaderView &);
            };
        }

    }

}

#endif
