#ifndef _H_42D533765FB5D019836DF43E9D4EBBE9_SingleJointPosition_Feedback__H_
#define _H_42D533765FB5D019836DF43E9D4EBBE9_SingleJointPosition_Feedback__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            struct  SingleJointPosition_Feedback_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ action_goal_id_;
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double position_;
                ::DDS::Double velocity_;
                ::DDS::Double error_;
            };

            typedef DDS_DCPSStruct_var<SingleJointPosition_Feedback_> SingleJointPosition_Feedback__var;
            typedef DDS_DCPSStruct_out < SingleJointPosition_Feedback_> SingleJointPosition_Feedback__out;

        }

    }

}

#endif /* _H_42D533765FB5D019836DF43E9D4EBBE9_SingleJointPosition_Feedback__H_ */
