#ifndef _H_5D3F8CD6095994F90640C8A5D3C0688F_SingleJointPosition_Goal_Request__H_
#define _H_5D3F8CD6095994F90640C8A5D3C0688F_SingleJointPosition_Goal_Request__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            struct  SingleJointPosition_Goal_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ action_goal_id_;
                ::DDS::Double position_;
                ::builtin_interfaces::msg::dds_::Duration_ min_duration_;
                ::DDS::Double max_velocity_;
            };

            typedef DDS_DCPSStruct_var<SingleJointPosition_Goal_Request_> SingleJointPosition_Goal_Request__var;
            typedef SingleJointPosition_Goal_Request_& SingleJointPosition_Goal_Request__out;

        }

    }

}

#endif /* _H_5D3F8CD6095994F90640C8A5D3C0688F_SingleJointPosition_Goal_Request__H_ */
